/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
/*_______________________________________________________________________
 |
 | blixscore.h - handles reading and writing highscores
 |
 | There are three levels of highscore stored at different places
 | the first level is in the users home directory to store the personal
 | highscores. The second is stored in "/usr/tmp/Indyzone/blix" and
 | holds the systemwide scores. The third - more interesting level - 
 | holds the worldwide records (for people who can reach the server)
 | The format of the file is the same in all three cases.
 |
 | (c) 1994 Frans van Hoesel, hoesel@chem.rug.nl
 |     Xtreme Graphics Software
 | should add file locking;
 | tijdens writeimage de image wel even copieren frans!
 |
*/

#ifndef BLIXSCORE_H__SEEN

#include "blixscore_io.h"

int gethostname (char *name, int namelen);

typedef struct userinfo_t {
    char host[48];
    char name[48];
    char home[256];
    char image[256];
    int score;
    long addr;
} userinfo_t;
 
void doscore(int score);
void init_tmpdir(void);
void printscore(char *header, scorelist_t *scorelist);
void init_server(void);
userinfo_t *getinf(void);
void showscore(int clearin, int score, int fadeout);

extern scorelist_t worldlist;
extern scorelist_t systemlist;
extern scorelist_t privatlist;

#define BLIXSCORE_H__SEEN
#endif
