/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
/*__________________________________________________________________
 |
 | blixscore_io.h 
 |
 | (c) 1994 Frans van Hoesel, hoesel@chem.rug.nl
 |               Xtreme Graphics Software
 |
*/

#ifndef BLIXSCORE_IO_H__SEEN

typedef struct scorelist_t {
    long game;
    long id;
    char names[7][64];
    char hosts[7][64];
    char images[7][256];
    long scores[7];
    long addrs[7];
} scorelist_t;

int write_data(int f, void *lbuf, int len);
int read_data(int f, void *lbuf, int maxlen);
int readstr(int f, char *s);
int writestr(int f, char *s);
int openscore(const char *path, float timeout);
int readscore(int f, scorelist_t *scorelist);
void writescore(int f, scorelist_t *scorelist);
void cleanup_images(scorelist_t *scorelist, char *dirnam, char *ext);

#define BLIXSCORE_IO_H__SEEN
#endif
