/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
/*_______________________________________________________________________
 |
 | blixsound.h - handles all the sound effects for blix.
 |
 |
 |	    (c) 1994 Frans van Hoesel, Xtreme Graphics Software.
 |
 */
 
 
#ifndef BLIXSOUND_H__SEEN


#define SFX_WELCOME		0
#define SFX_BEEP		1
#define SFX_EXPLOSION		2
#define SFX_EXPLOSION_L		3
#define SFX_LIFT		4
#define SFX_LIFT_L		5
#define SFX_TUNE_A		6
#define SFX_TUNE_B		7
#define SFX_TUNE_C		8
#define SFX_DONK		9
#define SFX_PLANET	       10
#define SFX_POP		       11
#define SFX_END		       12
#define SFX_N_SOUNDS	       13

void    end_sound(void ) ;
int     init_sound(void ) ;
void    set_volume(int level ) ;
void    sfx(int sound ) ;
void	sfx_pan(int sound, int pan);
int     toggle_sound(void ) ;
int     volume_change(int direction ) ;
int	toggle_tune(void);
void	tune_off(void);

extern int no_sfx;
extern int current_tune;
extern int playing_tune;

#define BLIXSOUND_H__SEEN
#endif
