/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
typedef struct Bitmap {
   	short *base; 		/* pointer to first word */
	short xsize, ysize;	/* dimensions of the bitmap */
	short xorig, yorig;	/* origin - used for cursors */
	short xmove, ymove;	/* move - used by characters */
	short sper;		/* shorts per row */
} Bitmap;

typedef struct glyph {
     float cscale, angle;
     float movex, movey;
     Bitmap *bm0;
     Bitmap *bm1;
} glyph;

typedef struct edge {
    struct edge *next;
    float ymax;
    float ymin;
    float x, y;
    float dxdy;
} Edge;	

typedef struct chardesc {
    short movex, movey;		/* advance */
    short llx, lly;		/* bounding box */
    short urx, ury;
    short *data;		/* char data */
    long datalen;		
} chardesc;

typedef struct objfnt {
    struct objfnt *freeaddr;	/* if freeaddr != 0, objfnt is one chunck */
    short type;
    short charmin, charmax;
    short nchars;
    short scale;
    chardesc *chars;
} objfnt;

objfnt *readobjfnt(char *name);
void drawaafntchar(objfnt *fnt, int c);
void aafontsetsize(objfnt *fnt, float pixhigh);
void aafontmoveto(float xpos, float ypos);
void get_charpos(float *x, float *y);
void charsetcolors(long col1, long col2);
