/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
/*_________________________________________________________________________
 |
 | io.h - file opening, parsing and closing routines
 |
 | only one file can be open at any time; but no check is made
 | 
 |     (c) 1993 Frans van Hoesel, Xtreme graphics software
 |
*/

#ifndef IO_H_SEEN

void errormsg(const char *format, ...);
void warningmsg(const char *format, ...);
int read_line(char *l);
int skipblanks(void);
void expect_ch(const char c);
float accept_float(void);
int accept_int(void);
char *accept_str(void);
int test_ch(const char c) ;
int test_str(const char *s);
void open_file(const char *file_name);
void close_file(void);
int read_str(const char *s);
int read_ch(const char c) ;
void skip_line(void);
char *lookahead(void);

#define IO_H_SEEN
#endif
