/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
/*__________________________________________________________________________
 |
 | lod.h - defines the constants used in determining the level of detail
 |
 | change them to match your preferences.
 | whenever the lod is greater then or equal to the constant specified,
 | that feature is turned on.
 |
 |     (c) 1993 Frans van Hoesel, Xtreme graphics software
*/

#ifndef LOD_H__SEEN

#define WALLS_UP   	1	/* walls have heights, otherwise flat only.
				 * which can be much faster because the flat
				 * walls don't need the zbuffer */
#define EXTRA_COARSE	0	/* circles arn't circles anymore */
#define LIVE_FIGURES	2	/* show the players as real figures, instead
				 * of simple colored boxes */
#define EXTRA_LIGHT	3	/* use two instead of one light */
#define TEXTURE_MAPS	4	/* apply texture maps */
#define EXTRA_FINE	5	/* use more polygons to represent circles */
#define LOD_H__SEEN
#endif

