/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
/*_______________________________________________________________
 |
 | players.h
 |
 | (c) Frans van Hoesel 1994, Xtreme Graphics Software
 |
*/

#ifndef PLAYERS_H__SEEN


typedef struct player_t {
    int player_type;
    int stage;
    int stage_cnt;
    Object base_object;
    Object curr_object;
    float dir[3];
    float pos[3];
    float speed;	        /* 0.068 is around one node per step */
    int currnode;
    int prevnode;
    struct player_t *next;
    struct player_t *prev;
} player_t;

void draw_players(Matrix mat, Matrix invmat) ;
void init_players(void);
void players_action(void);
void do_player(player_t *p, int action);

#define PLAYERS_H__SEEN
#endif
