
     OORT(6D)         Silicon Graphics (Release 1.1)          OORT(6D)

     NAME
          oort - dune buggies in space game

     SYNOPSIS
          oort [ -h ] [ -i infile ] [ -o outfile ] [ -n player_name ]
          [ -T ttl ]

          oort -d demofile

     BACKGROUND
          The time is shortly after the discovery of alien constructs
          in the Bellatrix system and the outbreak of fighting over
          the structure named Bellatrix Zero (BZ).  Sentinel posts
          have detected an asteroid breaking from its normal orbit
          within the Oort Cloud.  Numerous probes have returned
          disturbing data about the asteroid, named simply Oort.  Oort
          is no asteroid, but an immense artifact actually made up of
          over 30,000 triangular panels disguised to look like a
          cratered asteroid.  Although its radius is just over 1.1
          kilometers, it possesses a gravitational field that is
          slightly higher than one-half gee at the surface.  Most
          disturbing of all, the new trajectory takes the artifact on
          a collision course with Earth.

          The four major conglomerates have sent mercenary forces to
          investigate Oort.  With them, they have brought the conflict
          that erupted with the discovery of BZ.

          While the battle rages on, Oort draws ever closer to its
          destination.

     DESCRIPTION
          Oort is a combat game allowing users to play against several
          players in a networked environment.  The user controls a
          Remote Armored VEhicle (RAVE) from an Orbital Fortress
          orbiting around Oort.  Satellites around Oort provide a
          radar view of the surface.  The RAVE feeds back visual data
          from its fix-mounted camera.

          Before each RAVE is launched, the user is given the
          opportunity to configure the vehicle.  Each RAVE has four
          bays for enhancement modules for augmenting the vehicle's
          lasers, shields, engine, electronic counter measures (ECM),
          and solar generators.  A RAVE can be equipped with one of
          three different transmissions.  The user can also choose a
          new conglomerate team to for which to fight.

          Once a RAVE has been configured, the vehicle can be launched
          to any location on Oort.  On the surface, use the RAVE's
          laser to take out enemy RAVEs.  Effective use of the the
          RAVE's ECM will hide it from the satellites' radar and
          enable the RAVE to either escape pursuit or surprise an

     Page 1                                          (printed 2/25/94)

     OORT(6D)         Silicon Graphics (Release 1.1)          OORT(6D)

          enemy.

     OPTIONS
          The following command line options are recognized.

          -h      Display help cards before starting oort.

          -i input_file
                  Specifies that packets will come from a file instead
                  of from the network.

          -d demo_file
                  This option allows oort to run in demo mode.  The
                  demo_file should be a file created with the -o
                  option.  The game will then display the view seen by
                  the player that created the demo_file.  While in
                  demo mode, most of the options described below are
                  inactivated.

          -o output_file
                  Specifies that packets will be written to a file
                  instead of broadcast to the network.

          -n player_name
                  Sets your playing name.  The default name is your
                  login name.

          -T ttl  Specifies the maximum number of times the multicast
                  packets can be forwarded between networks.  See the
                  TCP/IP User's Guide for details on setting up
                  multicast routing.

     ABOUT THE RAVE VEHICLE
          The RAVE is an extremely rugged and maneuverable, three-
          wheeled vehicle.  Although it can absorb huge shocks
          directed through it wheels, the top is fragile; overturning
          the RAVE will result in its destruction.

          The RAVE contains solar panels on its top surface.  The
          solar generator output is directly related to the angle of
          the sun's rays on the top of the RAVE.  Power output will be
          highest when the sun is directly overhead.  The solar
          generator will not produce any power when the RAVE is on the
          dark side of Oort.  A small nuclear power source will,
          however, generate minimal power to permit the vehicle to
          travel.

          The RAVE's shields can withstand a direct laser hit without
          damage occurring to the RAVE itself.  The shields regenerate
          themselves over time.  Once the shields strength drops to
          zero, however, the RAVE will be destroyed.

     Page 2                                          (printed 2/25/94)

     OORT(6D)         Silicon Graphics (Release 1.1)          OORT(6D)

          The RAVE laser is the only weapon on board the vehicle and
          can be fired anywhere in the view of the RAVE.  The
          effectiveness of the laser decreases with distance.  A full
          laser charge will use up 25% of the total laser power
          reserve.  The laser can be fired when the reserve is less
          than 25% of maximum, but laser effectiveness will be
          proportionately reduced.

     VEHICLE CONFIGURATION
          The vehicle configuration screen is displayed when oort is
          first started and whenever your RAVE is destroyed.  Buttons
          labeled one through two are displayed for the five
          enhancement options:  laser, shields, engine, ECM, and solar
          generator.  Selecting 0 for an option configures the RAVE
          with the standard setting.  Additional performance or
          capability is added when either 1 or 2 is selected.  Use the
          left mouse button to select an on-screen button.  The number
          of configuration points not used are displayed beneath the
          five options.

          Augmenting your laser means it inflicts more damage with
          each hit.  Enhancing your shields means they take less
          damage with each laser strike.  Increasing your engine
          strength increases both your acceleration and top speed.
          Enhancing your ECM equipment increases the length of time
          you can remain "cloaked".  Finally, augmented solar
          generators will replenish your power more quickly.

          The transmission gearing is selected by choosing either L,
          M, or H for the gearing option.  Selecting L means the RAVE
          will have better acceleration, but a lower top speed.
          Selecting H will result in a higher top speed, but slower
          acceleration.  The M choice provides medium acceleration and
          an average top speed.

          The team is chosen by selecting either the A, B, C, or D
          button.  The text off to the side shows the number of
          players for each team.  The color of the text indicates
          which team you have currently selected.

          When the RAVE is configured as desired and an excessive
          number of configuration points have not been used, click on
          the Done button to end RAVE configuration and to start the
          landing site selection procedure.

     LANDING SITE SELECTION
          In the landing site selection phase, the main screen will
          display an orbital view of Oort.  Use the middle mouse to
          rotate the artifact.  The radar view will be updated to
          match the main view.  Other RAVEs on the surface will be
          displayed in the radar view, color coded by team (except
          those that are using ECM).  The radar view can be zoomed and

     Page 3                                          (printed 2/25/94)

     OORT(6D)         Silicon Graphics (Release 1.1)          OORT(6D)

          unzoomed with the a and z keys.  The small, yellow cross-
          hair in the radar view corresponds to the large, yellow
          cross-hair in the main view.  Coordinating the two views
          allows you to land very close to an opponent (especially if
          dropping while your ECM is active).

          To pick a landing site and initiate the launch sequence,
          position the cursor over the landing site and press the left
          mouse button.  The RAVE will be launched and the main view
          will switch to the view transmitted by the RAVE as it
          descends toward Oort.  During the descent, moving the mouse
          left and right will turn the RAVE in the corresponding
          direction, so that the RAVE will be facing in the proper
          direction at touchdown.

          Caution is necessary in picking a landing site, since the
          RAVE is subject to laser fire during descent.

     GROUND COMBAT
          On the ground, the main view is that transmitted by the
          RAVE's onboard camera.  The yellow box in the center of the
          main view is the pitch/roll indicator and displays the
          artificial horizon.

          If the RAVE is stationary (or moving slowly), enemy orbital
          fortresses will lock on and fire on it.  The orbitals'
          lasers are not able to track RAVEs moving at higher speeds.

          The speed of the RAVE is controlled by the keys:  q (large
          negative acceleration), w (small negative acceleration), e
          (small positive acceleration), and r (large positive
          acceleration).  The space key applies the brakes.  A forward
          speed is displayed on the control panel in green.  A reverse
          speed is displayed in red.  The top reverse speed is always
          half of the maximum forward speed.

          The RAVE is turned by moving the cursor to the left or right
          of the pitch/roll indicator box.  The RAVE can only be
          turned when the front wheel is on the ground.  The rate of
          turn is proportional to the speed of the RAVE.  The RAVE
          will not turn if the speed is zero and the brakes are
          applied.

          The laser is fired by pressing the left mouse button.  The
          laser will be fired in the direction indicated by the
          cursor.  There is a slight delay in firing the laser, so a
          small lead is necessary when firing at a moving target.  The
          laser itself is not visible to the human eye, but successful
          shots are indicated by the temporary visibility of the
          target's shield (or explosion).

          The identity of a RAVE can be determined by pressing the

     Page 4                                          (printed 2/25/94)

     OORT(6D)         Silicon Graphics (Release 1.1)          OORT(6D)

          right mouse button while the cursor is positioned over the
          vehicle.  The owner of the RAVE will be displayed in the
          text window.

          At higher speeds, the RAVE can leave the ground when going
          over ridges or rough terrain.  When airborne, there is no
          means of controlling the RAVE.

     GENERAL
          Oort can be played with a window of any (reasonable) size.
          At larger window sizes, all the text is visible, but the
          frame rate may suffer due to pixel fill bottlenecks (at
          least on the Indigo).  Smaller window sizes should result in
          higher frame rates, but the text on the conrol panel may
          become illegible.  The text in the info screen can be made
          larger by decreasing the number of text lines displayed as
          described in the customization section below.  The maximum
          frame rate allowed is 15 frames per second.  The F1 key
          toggles the Performer frame rate display in the main view.

          The commands below are primarily available during the
          landing and combat phase, although some are available at any
          time.  During the game, the h key can be used to toggle an
          on-screen help summary during the landing and combat phase.

          Press the ESCAPE key to exit oort.

          ECM is activated and deactivated by pressing the c key.
          When the ECM power reserve is depleted, the ECM is
          automatically turned off.  The reserve will replenish itself
          if excess power is available.  While the ECM is activated,
          the RAVE will not show up on other RAVE's radars.

          The volume of the audio feedback can be controlled with the
          up and down arrow keys.  The audio is turned off by setting
          the volume to zero.

          The current vehicle configuration option can be displayed to
          the info screen by hitting the i key.

          The RAVE's self-destruct sequence can be initiated by
          hitting the b key.  The self-destruct sequence takes 10
          seconds to complete.  The sequence can be stopped at any
          time by hitting the b key again.

          While reading packets from a file (using the -i command line
          option), the vehicles can be suspended by pressing the f
          key.  Hitting the f key again resumes their movement.

          The m key can be used to enter message mode.  Up to 80
          characters can then be typed in as a message to be broadcast
          to all players.  Hitting enter sends the message.  If no

     Page 5                                          (printed 2/25/94)

     OORT(6D)         Silicon Graphics (Release 1.1)          OORT(6D)

          characters were typed in, then no message is sent.  The
          message is displayed at the bottom of the text screen as it
          is typed in.

          The t key is similar to the message mode described above
          except that the message is only sent to member of your
          current team.

          The l key will print the current latitude and longitude of
          your RAVE to the info screen.

          The p key is used to pause processing of mouse movement.
          This is convenient when you need to move the mouse outside
          of the game window, but don't want the RAVE to respond to
          the mouse movement.  Pressing the p key again will resume
          interpretation of the mouse movement.

     CUSTOMIZATION
          Upon startup, oort looks in the current directory for a
          .oortrc file.  If not file is found, your home directory is
          searched.  If .oortrc is found in either location, it is
          scanned to set several options.

          The format of the file is similar to the format used to set
          X resources.  A line consists of an identifier string, a
          colon, and the value.  Valid customizations are:

          terrainColor
               This option should be followed by 3 floating point
               values in the range of 0 to 1 inclusive representing
               the red, green, and blue components of the terrain
               color, respectively.

          teamColorA
               This option sets the color of players belonging to team
               A.  The color is specified in the same format as the
               terrain color.  Note that this only affects your
               display; it does not change the color of your RAVE on
               other players' screens.

          teamColorB
               Specifies the color of team B vehicles.

          teamColorC
               Specifies the color of team C vehicles.

          teamColorD
               Specifies the color of team D vehicles.

          name Specifies your name as reported to other players.  The
               maximum length is 12 characters.  This value is
               overridden by the command line -n option.

     Page 6                                          (printed 2/25/94)

     OORT(6D)         Silicon Graphics (Release 1.1)          OORT(6D)

          volume
               This sets the initial audio volume.  Valid values are
               integer values from 0 (no sound) to 10 (maximum
               volume), inclusive.

          textLines
               The expected integer value controls how many lines of
               text are displayed in the info screen.  Fewer number of
               text lines will result in larger text.  The maximum
               value is 20.  The minimum value is 1, although a value
               smaller than 8 makes the info screen practically
               useless.

          configuration
               This specifies the initial configuration of the RAVE.
               These values should be specified as 5 integer values in
               the range 0 to 2 inclusive corresponding to the number
               of configuration points used for the shields, laser,
               engine, ECM, and solar generators, respectively.  These
               five values should be followed by a character
               indicating low (L), medium (M), or high (H) gearing
               followed by a character indicating the default team (A,
               B, C, or D).

          TTL  This specifies the time to live setting of the
               multicast packets.  The default setting is 8.  Valid
               values range from 1 to 32.  This value is overridden by
               any value specified on the command line with the -T
               option.

          The following default .oortrc file is created automatically
          for you in your home directory if a configuration file is
          not found.

               terrainColor:   0.54 0.50 0.36
               textLines:      12
               teamColorA:     1.00 1.00 1.00
               teamColorB:     1.00 0.25 0.25
               teamColorC:     0.25 1.00 0.25
               teamColorD:     0.25 0.25 1.00

     NOTES
          Oort IRIS Performer 1.2 runtime libraries and graphics z-
          buffer capabilities.  24 bitplanes of color is preferred.

          Oort looks for the data files in /usr/local/data/oort by
          default.  If the environment variable, OORT_DIR, is set to a
          alternate directory, the program will look in that directory
          instead.

          Oort uses multicast to communicate between machines.  It
          looks for the port number assigned to sgi-oortnet in

     Page 7                                          (printed 2/25/94)

     OORT(6D)         Silicon Graphics (Release 1.1)          OORT(6D)

          /etc/services.  The default behavior is to use port number
          5137.  If you wish to have oort use a different port number,
          add

                            sgi-oortnet     5137/udp

          to /etc/services, replacing 5137 with the desired number.
          If you are running NIS, you should make the change on the
          NIS master.

     SEE ALSO
          bz(6D), mrouted(1M).

     FILES
          $HOME/.oortrc,./.oortrc, customization files.
          /usr/local/data/oort/oort_help.sc, Showcase help file.
          /usr/local/data/oort/*.sound, audio files.
          /usr/local/data/oort/c.oort, fixed width text data.
          /usr/local/data/oort/h.oort, variable width text data.
          /usr/local/data/oort/oort.data, terrain geometry data.
          /usr/local/data/oort/shield.data, shield geometry data.
          /usr/local/data/oort/vehicle.data, vehicle geometry data.

          And, for the Developer Toolbox version, the above are to be
          found under the CDROM mount point as:

          $HOME/.oortrc,./.oortrc, customization files.
          src/exampleCode/games/IndiZone/data/oort/oort_help.showcase, Showcase help file.
          src/exampleCode/games/IndiZone/data/oort/*.sound, audio files.
          src/exampleCode/games/IndiZone/data/oort/c.oort, fixed width text data.
          src/exampleCode/games/IndiZone/data/oort/h.oort, variable width text data.
          src/exampleCode/games/IndiZone/data/oort/oort.data, terrain geometry data.
          src/exampleCode/games/IndiZone/data/oort/shield.data, shield geometry data.
          src/exampleCode/games/IndiZone/data/oort/vehicle.data, vehicle geometry data.
          src/exampleCode/games/IndiZone/data/oort/terrain.bw, terrain used on REs.

     AUTHOR
          Chris Fouts, Silicon Graphics.

     Page 8                                          (printed 2/25/94)

