/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
/*------------------------------------------------------------------------------
 *
 * OORT - text.h - Header for text drawing routines.
 *
 * $Id: text.h,v 1.2 1994/01/28 00:22:01 mtj Exp $
 * 
 * Chris Fouts - May, 1993.
 * 
 *----------------------------------------------------------------------------*/

#ifndef	OORT_TEXT_H
#define	OORT_TEXT_H

typedef void (*FontDrawFunc)( short * ) ;

typedef struct {
	long		heightUp ;
	long		heightLo ;
	float		scale ;
	FontDrawFunc	draw ;
	short		*widths ;
	short		*offsets ;
	short		*data ;
	short		type ;
	short		minChar ;
	short		maxChar ;
	} GeoFont ;



#define	OORT_FONT	0x4f6f6e74	/* Magic = Oont */

#define	BGNTMESH	(1)
#define	SWAPTMESH	(2)
#define	ENDBGNTMESH	(3)
#define	RETENDTMESH	(4)
#define	RETTMESH	(5)

#define	BGNLOOP		(1)
#define	ENDBGNLOOP	(2)
#define	RETENDLOOP	(3)
#define	RETLOOP		(4)

/* BEGIN PROTOTYPES text.c */
GeoFont *   copyFont( GeoFont *src ) ;
void        drawString( GeoFont *gf, char *str ) ;
float       getFontSize( GeoFont *gf ) ;
float       getStrWidth( GeoFont *gf, char *str ) ;
GeoFont *   loadFont( char *name ) ;
int         maxCharsInWidth( GeoFont *gf, char *str, float width ) ;
void        positionText( float x, float y ) ;
void        setFontSize( GeoFont *gf, float size ) ;
/* END PROTOTYPES text.c */

#endif /* OORT_TEXT_H */
