/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
/*------------------------------------------------------------------------------
 *
 * @(#) - Oort - Host validation routines
 *
 * $Id: validate.h,v 1.2 1994/01/28 00:22:33 mtj Exp $
 *
 * Chris Fouts - May, 1993.
 *
 *----------------------------------------------------------------------------*/

#if !defined(VALIDATE_H)

#define VALIDATE_H

#define	NG_MIN_TTL	1
#define	NG_DEFAULT_TTL	8
#define	NG_MAX_TTL	32
#define	MAXPLAYERS	40

typedef	long	ngMagic ;


struct ngAck {
	ngMagic			magic ;
	long			id ;
	long			ackId ;
	unsigned short	key ;
	} ;


struct ngCensus {
	ngMagic			magic ;
	long			id ;
	long			nPlayers ;
	unsigned long		chksum ;
	unsigned long		chkxor ;
	long			list[MAXPLAYERS] ;
	} ;


/* BEGIN PROTOTYPES validate.c */
void                    checkToSendCensus( void ) ;
struct ngCensusList *   findHostCensus( long id ) ;
void                    ngAcknowledge( long hostId, unsigned short key ) ;
void                    ngAddHostToCensus( long id ) ;
void                    ngDprintf( char *fmt, ... ) ;
void                    ngDropHost( long hostId ) ;
void                    ngDroppedByHost( long hostId ) ;
char                   *ngHostNameFromId( long id ) ;
void                    ngInit( long id, unsigned short key, char *name,
                            ngMagic drop, ngMagic invalidate, ngMagic census,
                            ngMagic ack, ngMagic quit, char *logFile ) ;
void                    ngInitCensusPacket( long id ) ;
void                    ngInvalidateHost( long hostId ) ;
char *                  ngPrintTime( void ) ;
void                    ngQuitHost( long hostId ) ;
void                    ngRegisterKey( unsigned short key ) ;
void                    ngRemoveHost( long hostId ) ;
void                    ngRemoveHostFromCensus( long id ) ;
void                    ngSendQuitPacket( void ) ;
int                     ngValidHost( long hostId ) ;
int                     ngValidKeyedHost( long hostId, unsigned short key ) ;
char *                  printDate( void ) ;
void                    processNgCensus( struct ngCensus *input ) ;
void                    validationSummary( void ) ;
/* END PROTOTYPES validate.c */

#endif /* !defined(VALIDATE_H) */
