/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
#ifndef CONTROL_H
#define	CONTROL_H

#include <Xm/Form.h>

enum RadioSetting	{ RadioOff = 0, RadioTeam = 1, RadioAll = 2 };
enum SoundSetting	{ SoundOff = 0, SoundWarnings = 1, SoundAll = 2 };	

Widget			makeControlPanel(Widget parent);
void			controlPanelReset();
void			controlPanelAdvance(float dt);
int			keyEvent(XEvent* e);

RadioSetting		radioDial();
void			radioDial(RadioSetting r);

SoundSetting		soundDial();
void			soundDial(SoundSetting s);

void			weaponChanged();
void			laserChanged();
void			missileChanged();
void			thrustChanged();
void			fuelChanged();
void			shieldsChanged();
void			targetChanged();

void			scoreChanged();
void			playersChanged();
void			flagChanged();

void			addMessage(char* msg);

#endif
