/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
#ifndef EXTERN_H
#define	EXTERN_H

#include <Inventor/nodes/SoPerspectiveCamera.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoTranslation.h>
#include <Inventor/SoXt.h>
#include <Inventor/SoXtRenderArea.h>
class ShipObject;

// display.c++
extern Display*		display;		// X display
extern Widget		mainWindow;		// top-level shell widget
extern SoXtRenderArea*	view;			// view screen

// main.c++
extern int		buttonPressed[3];	// mouse button states
extern int		frameNumber;
extern int		frameDrawn;

// ship.c++
extern ShipObject*	myShip;			// pointer to my ship

// universe.c++
extern SoSeparator*		universe;	// universe database
extern SoPerspectiveCamera*	camera;		// ship's camera
extern SoTranslation*		position;	// camera position
extern SoSeparator*		ships;		// all ships under here

#endif
