/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
#ifndef	REGULARSHIP_H
#define	REGULARSHIP_H

#include "ship.h"
class SoCone;

class RegularShip : public ShipObject {
  public:
			RegularShip(NetId, Team, const char*);
			~RegularShip();

    ShipClass		shipClass() const;
    float		mass() const;
    float		angularAccel() const;
    float		engineMaxForce() const;
    float		engineResponse() const;
    float		fuelRate() const;
    float		shieldMaximum() const;
    float		shieldRecovery() const;
    int			maxMissiles() const;
    float		missileEnergy() const;
    float		laserPower() const;

  protected:
    void		newEngineOutput();
    SbVec3f		missileSource(int) const;
    int			missileSilos() const;

  private:
    SoCone		*rightEngine, *leftEngine;
};

#endif
