/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
#ifndef SW_H
#define	SW_H

#ifndef	FALSE
#define	FALSE	0
#endif
#ifndef	TRUE
#define	TRUE	(!FALSE)
#endif

#include <math.h>

#define	SERVERPORT	5701
#define	BROADCASTPORT	5702
#define	RADIOPORT	5703

#define	MAXPLAYERS	20			// max players at once
#define	MAXMISSILES	4			// max missiles fired at once
#define	MAXHITS		5			// max simultaneous visible hits
#define	MAXNAMELEN	24			// max length of call sign
#define	NUMTEAMS	4			// number of teams

#define	GAMEWIDTH	1000
#define	PANELHEIGHT	240
#define	ASPECT		(2.0/1.0)
#define	HEIGHTANGLE	(M_PI/6.0)
#define	HITHERPLANE	1.0
#define	YONPLANE	25000.0			// 25 kilometers
#define	LASERRANGE	4000.0			// 4 kilometers
#define	MAXMESSAGES	20
#define	NUMSTARS	500
#define	MAXASTEROIDS	36

#define	FIELDSIZE	5000.0			// game field 10 km on a side
#define	BASERADIUS	250.0			// 500 meter diameter
#define	FLAGSIZE	10.0			// 10 meters on a side

enum Active		{ ObjectInactive = 0,
			  ObjectActive = 1,
			  ObjectPaused = 2 };
enum Team		{ NoTeam = -1,
			  RedTeam = 0,
			  GreenTeam = 1,
			  BlueTeam = 2,
			  PurpleTeam = 3 };
enum FlagState		{ FlagNoExist,
			  FlagReady,
			  FlagOnShip };
enum ObjectType		{ LastObject = -1,
			  TeamBaseObject = 0,
			  AsteroidObject };
enum ShipClass		{ ShipClassRegular = 0 };

enum Weapon		{ NoWeapon = -1, Laser = 0, Missile = 1 };
enum			{ LeftMouseButton = 0,
			  MiddleMouseButton = 1,
			  RightMouseButton = 2 };

#endif
