/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
#ifndef UNIVERSE_H
#define	UNIVERSE_H

class SoSeparator;

SoSeparator*		makeUniverse();
void			deleteUniverse();
void			universeAdvance(float dt);

Team			insideBase(float p[3], float r);
float*			basePosition(Team);
void			drawRadarBase(Team);

int			numberAsteroids();
float*			asteroidPosition(int);
float			asteroidRadius(int);
void			asteroidVisibility(int num, long child);
int			hitAsteroid(float p[3], float r);
void			gravityAcceleration(float p[3], float a[3]);
void			drawRadarAsteroid(int num);

SoSeparator*		flagGeometry(Team);
void			flagInSpace(Team, int isSomewhereInSpace);
void			flagVisibility(Team, int visible);

#endif
