/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
#include <stdio.h>
#include <gl.h>
#include <math.h>

#include "vector.h"
#include "display.h"
#include "misc.h"
#include "camera.h"
#include "creatures.h"

VECTOR camera_from;		/* camera position */
VECTOR camera_to;		/* lookat point */

extern CREATURE creatures[MAX_PLAYERS];
extern short me; /* index of my creature */
extern VECTOR looking;
extern float facing;

/*
	Initialize the camera position and lookat point.
*/

void camera_init()
{
  VECTOR init;
  
/*  VEC_SET(init, 0.0, 0.0, 1.0); */
  
/*  camera_update(0.,20.,init); */
  facing = creatures[me].yrot - 90;
  VEC_SET(looking, fcos(RADIANS(-facing)), 0, fsin(RADIANS(-facing)));
  camera_update(creatures[me].position[0], creatures[me].position[2]);
/*
    VEC_SET(camera_from, 0.0, 10.0, 50.0);
    VEC_SET(camera_to, 0.0, 4.0, 0.0);
*/
}

/*
	Aim the camera before we draw the next frame.
*/

void camera_aim()
{
    static Matrix identity =  {
	1.0, 0.0, 0.0, 0.0,
	0.0, 1.0, 0.0, 0.0,
	0.0, 0.0, 1.0, 0.0,
	0.0, 0.0, 0.0, 1.0
    };

    loadmatrix(identity);
    lookat(VEC_EXPAND(camera_from), VEC_EXPAND(camera_to), 0.0);
}

/*
	Update the position of the camera for the next frame.
*/

void camera_update(float dx, float dy)
{
  static float angle = 0.0;
  VECTOR direction;

  VEC_SET(camera_to, dx, 4.0, dy);

  VEC_COPY(direction, looking);
  
  VEC_MULT(direction, 30.0);
  VEC_ADD(camera_from, camera_to, direction);
  camera_from[1] = 6.0;

}
