/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
#include <stdio.h>
#include <sys/time.h>

#include "clock.h"

float system_clock()
{
  static int init = 1;
  static struct timeval tp1;
  struct timeval tp2;
  float sec, usec;

  if (init)
  {
    gettimeofday(&tp1, NULL);
    init = 0;

    return 0.0;
  }

  gettimeofday(&tp2, NULL);

  sec = tp2.tv_sec - tp1.tv_sec;
  usec = tp2.tv_usec - tp1.tv_usec;
  if (usec < 0.0)
  {
    usec += 1000000.0;
    sec -= 1.0;
  }

  return sec + usec/1000000.0;
}
