/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
#include <stdio.h>
#include <gl.h>
#include "misc.h"
#include "creatures.h"
#include "game.h"

CREATURE creatures[MAX_PLAYERS];
VECTOR shadow_vector;

extern short me;  /* index of my creature */
extern short num_players; /* how many creatures are there */

/*****************
   creature creation!
********************/

void
make_beak(BEAK *beak, short index)
{
  /* bottom */
  VEC_SET(beak->bottom[0].v[0], 0., .1, -4.);
  VEC_SET(beak->bottom[0].v[2], 0., 0., -2.);
  VEC_SET(beak->bottom[0].v[1], .5, .2, -2.3);
  VEC_COPY(beak->bottom[0].c, cbeak);
  
  VEC_SET(beak->bottom[1].v[0], 0., .1, -4.);
  VEC_SET(beak->bottom[1].v[1], -.5, .2, -2.3);
  VEC_SET(beak->bottom[1].v[2], 0., 0., -2.);
  VEC_COPY(beak->bottom[1].c, cbeak);

  /* top */
  VEC_SET(beak->top[0].v[0], 0., .4, -4.);
  VEC_SET(beak->top[0].v[2], 0., .3, -2.);
  VEC_SET(beak->top[0].v[1], .5, .2, -2.3);
  VEC_COPY(beak->top[0].c, cbeak);
  
  VEC_SET(beak->top[1].v[0], 0., .4, -4.);
  VEC_SET(beak->top[1].v[1], -.5, .2, -2.3);
  VEC_SET(beak->top[1].v[2], 0., .3, -2.);
  VEC_COPY(beak->top[1].c, cbeak);

}


void
make_eyes(EYE eye[2], short index)
{
  /* first eye */
  VEC_SET(eye[0].white[0].v[0], 1.0, .5, -2);
  VEC_SET(eye[0].white[0].v[1], .5, .6, -2.5);
  VEC_SET(eye[0].white[0].v[2], .4, .7, -2);
  VEC_COPY(eye[0].white[0].c, cwhite);

  VEC_SET(eye[0].white[1].v[0], .4, .7, -2);
  VEC_SET(eye[0].white[1].v[1], .5, .6, -2.5);
  VEC_SET(eye[0].white[1].v[2], .2, .5, -2);
  VEC_COPY(eye[0].white[1].c, cwhite);

  VEC_SET(eye[0].white[2].v[0], .2, .5, -2);
  VEC_SET(eye[0].white[2].v[1], .5, .6, -2.5);
  VEC_SET(eye[0].white[2].v[2], 1.0, .5, -2);
  VEC_COPY(eye[0].white[2].c, cwhite);

  
  VEC_SET(eye[0].pupil[0].v[0], .75, .55, -2.25);
  VEC_SET(eye[0].pupil[0].v[1], .5, .6, -2.6);
  VEC_SET(eye[0].pupil[0].v[2], .45, .65, -2.25);
  VEC_COPY(eye[0].pupil[0].c, cblack);

  VEC_SET(eye[0].pupil[1].v[0], .45, .65, -2.25);
  VEC_SET(eye[0].pupil[1].v[1], .5, .6, -2.6);
  VEC_SET(eye[0].pupil[1].v[2], .35, .55, -2.25);
  VEC_COPY(eye[0].pupil[1].c, cblack);
  
  VEC_SET(eye[0].pupil[2].v[0], .35, .55, -2.25);
  VEC_SET(eye[0].pupil[2].v[1], .5, .6, -2.6);
  VEC_SET(eye[0].pupil[2].v[2], .75, .55, -2.25);
  VEC_COPY(eye[0].pupil[2].c, cblack);

  
  VEC_SET(eye[0].lid[0].v[0], 1.0, .5, -2);
  VEC_SET(eye[0].lid[0].v[1], .5, .65, -1.8);
  VEC_SET(eye[0].lid[0].v[2], .4, .7, -2);
  VEC_COPY(eye[0].lid[0].c, colors[index]);

  VEC_SET(eye[0].lid[1].v[0], .4, .7, -2);
  VEC_SET(eye[0].lid[1].v[1], .5, .65, -1.8);
  VEC_SET(eye[0].lid[1].v[2], .2, .5, -2);
  VEC_COPY(eye[0].lid[1].c, colors[index]);

  VEC_SET(eye[0].lid[2].v[0], .2, .5, -2);
  VEC_SET(eye[0].lid[2].v[1], .5, .65, -1.8);
  VEC_SET(eye[0].lid[2].v[2], 1.0, .5, -2);
  VEC_COPY(eye[0].lid[2].c, colors[index]);

/* second eye */
  VEC_SET(eye[1].white[0].v[0], -1.0, .5, -2);
  VEC_SET(eye[1].white[0].v[1], -.5, .6, -2.5);
  VEC_SET(eye[1].white[0].v[2], -.4, .7, -2);
  VEC_COPY(eye[1].white[0].c, cwhite);

  VEC_SET(eye[1].white[1].v[0], -.4, .7, -2);
  VEC_SET(eye[1].white[1].v[1], -.5, .6, -2.5);
  VEC_SET(eye[1].white[1].v[2], -.2, .5, -2);
  VEC_COPY(eye[1].white[1].c, cwhite);

  VEC_SET(eye[1].white[2].v[0], -.2, .5, -2);
  VEC_SET(eye[1].white[2].v[1], -.5, .6, -2.5);
  VEC_SET(eye[1].white[2].v[2], -1.0, .5, -2);
  VEC_COPY(eye[1].white[2].c, cwhite);

  
  VEC_SET(eye[1].pupil[0].v[0], -.75, .55, -2.25);
  VEC_SET(eye[1].pupil[0].v[1], -.5, .6, -2.6);
  VEC_SET(eye[1].pupil[0].v[2], -.45, .65, -2.25);
  VEC_COPY(eye[1].pupil[0].c, cblack);

  VEC_SET(eye[1].pupil[1].v[0], -.45, .65, -2.25);
  VEC_SET(eye[1].pupil[1].v[1], -.5, .6, -2.6);
  VEC_SET(eye[1].pupil[1].v[2], -.35, .55, -2.25);
  VEC_COPY(eye[1].pupil[1].c, cblack);
  
  VEC_SET(eye[1].pupil[2].v[0], -.35, .55, -2.25);
  VEC_SET(eye[1].pupil[2].v[1], -.5, .6, -2.6);
  VEC_SET(eye[1].pupil[2].v[2], -.75, .55, -2.25);
  VEC_COPY(eye[1].pupil[2].c, cblack);

  VEC_SET(eye[1].lid[0].v[0], -1.0, .5, -2);
  VEC_SET(eye[1].lid[0].v[1], -.5, .65, -1.8);
  VEC_SET(eye[1].lid[0].v[2], -.4, .7, -2);
  VEC_COPY(eye[1].lid[0].c, colors[index]);

  VEC_SET(eye[1].lid[1].v[0], -.4, .7, -2);
  VEC_SET(eye[1].lid[1].v[1], -.5, .65, -1.8);
  VEC_SET(eye[1].lid[1].v[2], -.2, .5, -2);
  VEC_COPY(eye[1].lid[1].c, colors[index]);

  VEC_SET(eye[1].lid[2].v[0], -.2, .5, -2);
  VEC_SET(eye[1].lid[2].v[1], -.5, .65, -1.8);
  VEC_SET(eye[1].lid[2].v[2], -1.0, .5, -2);
  VEC_COPY(eye[1].lid[2].c, colors[index]);

}

void 
make_tail(TAIL *tail, short index)
{
  VEC_SET(tail->poly[0], .5, -.3, 2);
  VEC_SET(tail->poly[1], -.5, -.3, 2);
  VEC_SET(tail->poly[2], -1, -.6, 3);
  VEC_SET(tail->poly[3], 1, -.6, 3);
  VEC_COPY(tail->c, colors[index]);
}

void 
make_wings(WING wing[2], short index)
{
  VEC_SET(wing[0].poly1[0], -.5, 0.0, -1.0);
  VEC_SET(wing[0].poly1[1], -.5, 0.0, 1.0);
  VEC_SET(wing[0].poly1[2], -2.5, 0.0, 1.5);
  VEC_SET(wing[0].poly1[3], -2.5, 0.0, -1.5);
  VEC_COPY(wing[0].c, colors[index]); 
  
  VEC_SET(wing[0].poly2[0], -2.5, 0.0, 1.5);
  VEC_SET(wing[0].poly2[1], -2.5, 0.0, -1.5);
  VEC_SET(wing[0].poly2[2], -4.5, -1.0, 0.0);
  VEC_COPY(wing[0].c, colors[index]); 

  wing[0].p1yrot = 0.;
  wing[0].p1zrot = 2.; 
  wing[0].p2zrot = 0.;
  wing[0].direction = 1.5;

  VEC_SET(wing[1].poly1[0], .5, 0.0, -1.0);
  VEC_SET(wing[1].poly1[1], .5, 0.0, 1.0);
  VEC_SET(wing[1].poly1[2], 2.5, 0.0, 1.5);
  VEC_SET(wing[1].poly1[3], 2.5, 0.0, -1.5);
  VEC_COPY(wing[1].c, colors[index]); 
  
  VEC_SET(wing[1].poly2[0], 2.5, 0.0, 1.5);
  VEC_SET(wing[1].poly2[1], 2.5, 0.0, -1.5);
  VEC_SET(wing[1].poly2[2], 4.5, -1.0, 0.0);
  VEC_COPY(wing[1].c, colors[index]); 

  wing[1].p1yrot = 0.;
  wing[0].p1zrot = -2.; 
  wing[1].p2zrot = 0.;
  wing[1].direction = 1.5;
}

void 
creatures_compute()
{
  short i;

  VEC_SET(creatures[0].position, 0.0, 4.0, 45.0);
  VEC_SET(creatures[1].position, 45.0, 4.0, -25.0); 
  VEC_SET(creatures[2].position, -45.0, 4.0, -25.0); 

  creatures[0].yrot = 0;
  creatures[1].yrot = 110;
  creatures[2].yrot = -110;

  for (i=0; i<MAX_PLAYERS; i++)
  {
    creatures[i].alive = TRUE;
    creatures[i].speed = 1.0;
    creatures[i].it = C_NOTIT;
    make_beak(&creatures[i].beak, i);
    make_wings(creatures[i].wings, i);
    make_tail(&creatures[i].tail, i);
    make_eyes(creatures[i].eyes, i);
  }
  creatures[1].it = C_IT;
}
    






/************* 
draw everything related to creatures 
***************/

void
draw_tail(TAIL tail, VECTOR position, short it)
{
  COLOR c;
  VECTOR placefog;

  VEC_ADD(placefog, tail.poly[0], position);
  
  if(it)
    VEC_COPY(c, cit);
  else
    VEC_COPY(c, tail.c);
  add_fog(c, placefog);
  c3s(c);
  bgnpolygon();
  v3f(tail.poly[0]);
  v3f(tail.poly[1]);
  v3f(tail.poly[2]);
  v3f(tail.poly[3]);
  endpolygon();

  VEC_COPY(c, cblack);
  add_fog(c, placefog);
  c3s(c);
  bgnclosedline();
  v3f(tail.poly[0]);
  v3f(tail.poly[1]);
  v3f(tail.poly[2]);
  v3f(tail.poly[3]);
  endclosedline();

  /* draw the shadow */
/*  pushmatrix();
  translate(VEC_EXPAND(shadow_vector));
  bgnpolygon();
  v3f(tail.poly[0]);
  v3f(tail.poly[1]);
  v3f(tail.poly[2]);
  v3f(tail.poly[3]);
  endpolygon();  
  popmatrix(); */
}
  
void 
draw_wing(WING wing, VECTOR position, short it)
{
  COLOR c;
  VECTOR tmp_vector;
  VECTOR placefog;
  
  pushmatrix();
  rot(wing.p1yrot, 'y');
  rot(wing.p1zrot, 'z');

  VEC_ADD(placefog, wing.poly1[0], position);
  
  if(it)
    VEC_COPY(c, cit);
  else
    VEC_COPY(c, wing.c);
  add_fog(c, placefog);
  c3s(c);
  bgnpolygon();
  v3f(wing.poly1[0]);
  v3f(wing.poly1[1]);
  v3f(wing.poly1[2]);
  v3f(wing.poly1[3]);
  endpolygon();

  VEC_COPY(c, cblack);
  add_fog(c, placefog);
  c3s(c);
  bgnclosedline();
  v3f(wing.poly1[0]);
  v3f(wing.poly1[1]);
  v3f(wing.poly1[2]);
  v3f(wing.poly1[3]);
  endclosedline();

  VEC_COPY(tmp_vector, wing.poly2[0]);
  VEC_NEG(tmp_vector);
  translate(VEC_EXPAND(wing.poly2[0]));
  rot(wing.p2zrot, 'z');
  translate(VEC_EXPAND(tmp_vector));

  VEC_ADD(placefog, wing.poly2[0], position);

  if(it)
    VEC_COPY(c, cit);
  else
    VEC_COPY(c, wing.c);
  add_fog(c, placefog);
  c3s(c);
  bgnpolygon();
  v3f(wing.poly2[0]);
  v3f(wing.poly2[1]);
  v3f(wing.poly2[2]);
  endpolygon();

  VEC_COPY(c, cblack);
  add_fog(c, placefog);
  c3s(c);
  bgnclosedline();
  v3f(wing.poly2[0]);
  v3f(wing.poly2[1]);
  v3f(wing.poly2[2]);
  endclosedline();
  popmatrix();

  /* draw the shadow */
/*  pushmatrix();
  translate(VEC_EXPAND(shadow_vector));
  rot(wing.p1yrot, 'y');
  rot(wing.p1zrot, 'z');
  bgnpolygon();
  v3f(wing.poly1[0]);
  v3f(wing.poly1[1]);
  v3f(wing.poly1[2]);
  v3f(wing.poly1[3]);
  endpolygon();

  translate(VEC_EXPAND(wing.poly2[0]));
  rot(wing.p2zrot, 'z');
  translate(VEC_EXPAND(tmp_vector));
  bgnpolygon();
  v3f(wing.poly2[0]);
  v3f(wing.poly2[1]);
  v3f(wing.poly2[2]);
  endpolygon();
  popmatrix();
*/  
}

void
draw_beak(BEAK beak, VECTOR position, short it)
{
  COLOR c;
  short i;
  VECTOR placefog;

  for (i=0; i<2; i++)
  {
    VEC_ADD(placefog, beak.bottom[i].v[0], position);
 
    pushmatrix();
    rotate(beak.bottom_xrot, 'x');
    
    VEC_COPY(c, beak.bottom[i].c);
    add_fog(c, placefog);
    c3s(c);
    bgnpolygon();
    v3f(beak.bottom[i].v[0]);
    v3f(beak.bottom[i].v[1]);
    v3f(beak.bottom[i].v[2]);
    endpolygon();

    VEC_COPY(c, cblack);
    add_fog(c, placefog);
    c3s(c);
    bgnclosedline();
    v3f(beak.bottom[i].v[0]);
    v3f(beak.bottom[i].v[1]);
    v3f(beak.bottom[i].v[2]);
    endclosedline();

    popmatrix();
    pushmatrix();
    rotate(beak.top_xrot, 'x');
    
    VEC_COPY(c, beak.top[i].c);
    add_fog(c, placefog);
    c3s(c);
    bgnpolygon();
    v3f(beak.top[i].v[0]);
    v3f(beak.top[i].v[1]);
    v3f(beak.top[i].v[2]);
    endpolygon();

    VEC_COPY(c, cblack);
    add_fog(c, placefog);
    c3s(c);
    bgnclosedline();
    v3f(beak.top[i].v[0]);
    v3f(beak.top[i].v[1]);
    v3f(beak.top[i].v[2]);
    endclosedline();
    popmatrix(); 
    
    /* draw the shadow */
/*    pushmatrix();
    translate(VEC_EXPAND(shadow_vector));
    bgnpolygon();
    v3f(beak.top[i].v[0]);
    v3f(beak.top[i].v[1]);
    v3f(beak.top[i].v[2]);
    endpolygon();
    popmatrix();
*/    
  }
 
}

void 
draw_eye(EYE eye, VECTOR position, CREATURE *creature, short stat)
{
  short i;
  COLOR c;
  VECTOR v;
  VECTOR placefog, tmp_vector;
  VECTOR zero={0., 0.6, 0.};
  VECTOR one ={0., 0.6, 2.};
  
  pushmatrix();

  /* if it's it and trying to zap someone, draw the zap */
  if (stat == C_HIT)
  {
    VEC_COPY(v, eye.pupil[0].v[1]);
    VEC_NORM(v);
    VEC_MULT(v, VEC_DIST(creature->position, 
			 creatures[creature->aimat].position));
    draw_tractor(eye.pupil[0].v[1], v);
  }
  else if (stat == C_MISS)
  {
    VEC_COPY(v, eye.pupil[0].v[1]);
    VEC_MULT(v, 2);
    draw_tractor(eye.pupil[0].v[1], v);
  }
  

  VEC_COPY(tmp_vector, eye.lid[0].v[1]);
  VEC_NEG(tmp_vector);
  translate(VEC_EXPAND(eye.lid[0].v[1]));
  rot(eye.yrot, 'y');
  translate(VEC_EXPAND(tmp_vector));    

  VEC_ADD(placefog, eye.white[0].v[0], position);
      
/*  c3s(cblack);
  bgnline();
  v3f(zero);
  v3f(one);
  endline();
  */
  for(i=0; i<3; i++)
    {
      VEC_COPY(c, eye.white[i].c);
      add_fog(c, placefog);
      c3s(c);
      bgnpolygon();
      v3f(eye.white[i].v[0]);
      v3f(eye.white[i].v[1]);
      v3f(eye.white[i].v[2]);
      endpolygon();

      VEC_COPY(c, cblack);
      add_fog(c, placefog);
      c3s(c);
      bgnclosedline();
      v3f(eye.white[i].v[0]);
      v3f(eye.white[i].v[1]);
      v3f(eye.white[i].v[2]);
      endclosedline();

      VEC_COPY(c, eye.pupil[i].c);
      add_fog(c, placefog);
      c3s(c);
      bgnpolygon();
      v3f(eye.pupil[i].v[0]);
      v3f(eye.pupil[i].v[1]);
      v3f(eye.pupil[i].v[2]);
      endpolygon();

      if(creature->it)
	VEC_COPY(c, cit);
      else
	VEC_COPY(c, eye.lid[i].c);
      add_fog(c, placefog);
      c3s(c);
      bgnpolygon();
      v3f(eye.lid[i].v[0]);
      v3f(eye.lid[i].v[1]);
      v3f(eye.lid[i].v[2]);
      endpolygon();
     
      VEC_COPY(c, cblack);
      add_fog(c, placefog);
      c3s(c);
      bgnclosedline();
      v3f(eye.lid[i].v[0]);
      v3f(eye.lid[i].v[1]);
      v3f(eye.lid[i].v[2]);
      endclosedline();

      /* draw the shadow */
/*      pushmatrix();
      translate(VEC_EXPAND(shadow_vector));
      bgnpolygon();
      v3f(eye.lid[i].v[0]);
      v3f(eye.lid[i].v[1]);
      v3f(eye.lid[i].v[2]);
      endpolygon();

      bgnpolygon();
      v3f(eye.pupil[i].v[0]);
      v3f(eye.pupil[i].v[1]);
      v3f(eye.pupil[i].v[2]);
      endpolygon();
      popmatrix();
*/
    }
  popmatrix();
  
}

/* borrowed the basic stuff for this from pods */
void
  draw_tractor(VECTOR zero, VECTOR one)
{
  int i;
  VECTOR s, w, x, v;
  float len;
  
  c3s(cwhite);
  for (i=0; i < 4; i++)
  {
    if ((random() % 3) == 0)
      linewidth(2);
    else
      linewidth(1);

    VEC_COPY(w, one);
    VEC_COPY(x, zero);
    
    bgnline();
    do
    {
      VEC_SUB(v, w, x);
      len = VEC_LEN(v);
      VEC_NORM(v);
      VEC_ADDS(x, x, 0.1, v);
      x[0] += ((random() % 1000)/500.0 - 1.0)*0.065;
      x[1] += ((random() % 1000)/500.0 - 1.0)*0.065;
      x[2] += ((random() % 1000)/500.0 - 1.0)*0.065;
      v3f(x);
    }
    while (len > 0.05);
    endline();
  }
}

void 
draw_position(VECTOR position)
{
  VECTOR zero={0., 1.0, 0.};

  c3s(cblack);
  bgnline();
  v3f(zero);
  v3f(position);
  endline();
}


void 
  line(VECTOR x, VECTOR y)
{
  c3s(cwhite);
  bgnline();
  v3f(x);
  v3f(y);
  endline();
}

void
creatures_draw()
{
  short i;
  VECTOR x, y;
  short it;
  PLAYER player;
  
  zbuffer(TRUE); 

  for (i=0; i<num_players; i++)
  {
    if (creatures[i].alive) 
    {
      if (creatures[i].it &&(i==me) && (time_it(STOP_TIMER, TIMER_IT) < .25))
      { /* drew.. put being tagged stuff here */ 
	c3s(cit);
	clear(); /* flash the screen orange to show that you've been tagged */
      }

      else
      {
	
	it = creatures[i].it;
	if (creatures[i].it == C_HIT)
	{
	  client_update_game(creatures[i].aimat); /* tell the world that aimat
						     is it */
	  creatures[i].it = C_NOTIT; 
	}
	else if (creatures[i].it == C_MISS) 
	  creatures[i].it = C_IT;
	
	pushmatrix();
	if((creatures[i].chip != NULL) && (creatures[i].holding_chip == FALSE))
	  if(creatures[i].status == C_SWOOP_DOWN) /* you're actually swooping.. */
	    draw_tractor(creatures[i].position, creatures[i].chip->position);
	  else /* you don't really have a chip */
	    creatures[i].chip = NULL;
	
	
	translate(VEC_EXPAND(creatures[i].position)); 
	rot(creatures[i].yrot, 'y');
	rot(creatures[i].zrot, 'z');
	rot(creatures[i].xrot, 'x');
      
	draw_wing(creatures[i].wings[0], creatures[i].position, creatures[i].it); 
	draw_wing(creatures[i].wings[1], creatures[i].position, creatures[i].it); 
	draw_tail(creatures[i].tail, creatures[i].position, creatures[i].it);
	pushmatrix();
	
	rot(creatures[i].beak.xrot, 'x'); 
	rot(creatures[i].beak.yrot, 'y'); 
	draw_beak(creatures[i].beak, creatures[i].position, creatures[i].it);
	draw_eye(creatures[i].eyes[0], creatures[i].position, &creatures[i], it);
	draw_eye(creatures[i].eyes[1], creatures[i].position, &creatures[i], it);
	popmatrix();
	popmatrix();
      }
    }
    
  }
  
  zbuffer(FALSE);
}












