/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
#ifndef _DEFS
#define _DEFS

#include "config.h"

#define BACKGROUND_COLOR	0x505050
#define CHIPS_PER_PLAYER        4

#define INFINITY  1.0e38
#define EPSILON   1.0e-10

#define RADIANS(a) ((a)*M_PI/180.0)
#define DEGREES(r) ((r)/M_PI*180.0)
#define SQR(a) ((a)*(a))
#define MIN(a, b) ((a) < (b) ? (a) : (b))
#define MAX(a, b) ((a) > (b) ? (a) : (b))
#define ABS(a) ((a) < 0.0 ? -(a) : (a))
#define CLAMP(a, b, c) ((b) > (a) ? (b) : ((a) > (c) ? (c) : (a)))
#define ZERO(a) (ABS(a) < EPSILON ? 0.0 : a)
#define SMOOTH(a) ((a)*(a)*(3.0 - 2.0*(a)))
#define SIGN(a) ((a) < 0 ? -1 : ((a) > 0 ? 1 : 0))
#define ODD(a) (((a/2) * 2) != a)
#define SQUARED(n) n*n
#define GET_PT(r) sqrt(SQUARED(r) - SQUARED(r/2)) 

typedef short COLOR[3];

/*static COLOR colors[3] = {
  {178, 101, 181},
  {140, 227, 157},
  {128, 145, 238}};
*/
static COLOR colors[3] = {
  {61, 13, 45},   /* pink */
  {22, 58, 45},   /* green */
  {33, 58, 101}}; /* blue */

static COLOR groundplane[3] =  {
  {111, 87, 103},
  {91, 109, 103},
  {97, 109, 131}};

static short cit[3] = {235, 0, 0};
static short crestart[3] = {255, 200, 0};
static short cbackground[3] = {80, 80, 80};
static short cblack[3] = {0, 0, 0};
static short cwhite[3] = {255, 255, 255};
static short cground[3] = {83, 17, 0};
static short cground_shadow[3] = {30, 30, 30};
static short cbeak[3] = {174, 171, 56};
static short cborder[3] = {255, 255, 60};


#endif
