/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
#ifndef _GAME
#define _GAME

#include "config.h"
#include "vector.h"

#define TRUE 1
#define FALSE 0


typedef struct {
  short new_player;
  short num_players;

  /* creature stuff */
  VECTOR creat_posit[3];
  float creat_xrot[3], creat_yrot[3], creat_zrot[3];
  float creat_beak_xrot[3], creat_beak_yrot[3];
  float creat_eyes_yrot[3][2];
  float creat_speed[3];
  short creat_alive[3];
  int   creat_status[3];
  short creat_aimat[3];
  short creat_it[3];
  short creat_done[3];
  
  /* chip stuff */
  VECTOR chip_position[3][4], chip_final_position[3][4];
  float  chip_yrot[3][4];
  int    chip_status[3][4]; 
  
} WORLD;

typedef struct 
{
  short  indexi, indexj;
  VECTOR position, final_position;
  float  yrot;
  int    status;
} CHIP_INFO;

typedef struct {
  short alive;
  
  /* creature stuff */
  short index;
  VECTOR creat_posit;
  float creat_xrot, creat_yrot, creat_zrot;
  float creat_beak_xrot, creat_beak_yrot;
  float creat_eyes_yrot[2];
  int   creat_status;
  short creat_aimat;
  float creat_speed;
  short creat_it; 
  
  /* chip stuff */
  short chip;
  short chip_indexi, chip_indexj;
  VECTOR chip_position;
  float  chip_yrot;
  int    chip_status;
} PLAYER;

void game_update_world(WORLD *world, float t);
void game_update_player(WORLD *world, PLAYER *player);


  
  
#endif
