/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
#include <stdio.h> 
#include <gl.h>
#include "defs.h"
#include "misc.h"

struct timeval t_move;
struct timeval t_it;

float random_num(float lo,
		    float hi)
{
  return(lo + drand48() * (hi - lo));
}

/* this either resets the time elapsed, or gets the time since last reset.
*/
float time_it(short init, short which)
{
  struct timeval tp2;
  double sec, usec;

  if (which == TIMER_MOVE)
  {
    if (init)
    {
      gettimeofday(&t_move, NULL);
      return(0.0);
    }
    
    gettimeofday(&tp2, NULL);
    
    sec = tp2.tv_sec - t_move.tv_sec;
    usec = tp2.tv_usec - t_move.tv_usec;
  }
  else 
  {
    if (init)
    {
      gettimeofday(&t_it, NULL);
      return(0.0);
    }
    
    gettimeofday(&tp2, NULL);
    
    sec = tp2.tv_sec - t_it.tv_sec;
    usec = tp2.tv_usec - t_it.tv_usec;
  }
    
  
  if (usec < 0.0)
  {
    usec += 1000000.0;
    sec -= 1.0;
  }
  
  return sec + usec/1000000.0;
}

/* this creates a random sorta circular border around a point, given bounds
   for the radius. we can use this function for both the hole and the 
   playing chips 
*/
void create_border(float bound1,
		   float bound2,
		   float depth,
		   VECTOR border[6])
{
  float blah;
  float radius;

  blah = random_num(bound1,bound2);
  VEC_SET(border[0], blah, depth, 0);

  radius = random_num(bound1,bound2);
  blah = GET_PT(radius);
  VEC_SET(border[1], radius/2, depth, -blah);

  radius = random_num(bound1,bound2);
  blah = GET_PT(radius);
  VEC_SET(border[2], -radius/2, depth, -blah);

  blah = random_num(bound1,bound2);
  VEC_SET(border[3], -blah, depth, 0);

  radius = random_num(bound1,bound2);
  blah = GET_PT(radius);  
  VEC_SET(border[4], -radius/2, depth, blah);

  radius = random_num(bound1,bound2);
  blah = GET_PT(radius);
  VEC_SET(border[5], radius/2, depth, blah);

}



