/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
#ifndef _MISC
#define _MISC

#include "vector.h"
#include <sys/time.h>

#define CLOCKWISE 0
#define COUNTERCLOCK 1
#define COLLINEAR 2
#define TIMER_MOVE              0
#define TIMER_IT                1
#define START_TIMER 1
#define STOP_TIMER 0

float random_num(float lo, float hi);
void create_border(float bound1, float bound2, float depth, VECTOR border[8]);
float time_it(short init, short which);
int turn(VECTOR p0, VECTOR p1, VECTOR p2);
int intersect_tl(VECTOR t1, VECTOR t2, VECTOR t3, VECTOR l1, VECTOR l2);

typedef struct triangle {
  VECTOR v[3], n;
  short c[3];
} TRIANGLE;

typedef struct tri_list {
  TRIANGLE *t;
  short wireframe; /* is it in wireframe mode or not? */
  struct tri_list *next;
} TRI_LIST;

typedef struct vert_list
{
  VECTOR v;
  struct vert_list *next;
} VERT_LIST;

#endif








