/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
#ifndef _NET
#define _NET

#include <sys/types.h>
#include <sys/time.h>
#include <netinet/in.h>

#define NET_ERROR	-1
#define NET_OK		0
#define NET_TIMEOUT	1
#define NET_LOCAL	2
#define NET_REMOTE	3

typedef struct {
  int fd;
  void (* cb_read)();
} NET_SELECT_FD;

typedef struct { 
  int count;
  int max;
  NET_SELECT_FD *sfd;
  fd_set fds_read;
  int has_timeout;
  struct timeval timeout;
} NET_SELECT;

int net_open(int port);
NET_SELECT *net_select_new();
void net_select_free(NET_SELECT *s);
void net_select_timeout(NET_SELECT *s, int sec, int usec);
int net_select_set(NET_SELECT *s, int fd, void (* cb_read)());
int net_select_loop(NET_SELECT *s);
int net_addr_lookup(struct sockaddr_in* addr, char* name);
int net_send_int(int fd, struct sockaddr_in *addr, int x);
int net_recv_int(int fd, struct sockaddr_in *addr);
void net_init(char *server_name);

#endif
