/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
#ifndef _PACKET
#define _PACKET

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

#include "world.h"

#define PACKET_ERROR	-1
#define PACKET_OK	0

typedef struct {
  unsigned char opcode;
  WORLD world;
} SERVER_PACKET;

typedef struct {
  unsigned char opcode;
  union {
    PLAYER player;
    int it; 
    CHIP_INFO chip;
  } item;
} CLIENT_PACKET;

int server_packet_send(int fd, struct sockaddr_in *addr,
	SERVER_PACKET *server_packet);
int server_packet_recv(int fd, struct sockaddr_in *addr,
	SERVER_PACKET *server_packet);
int client_packet_send(int fd, struct sockaddr_in *addr,
	CLIENT_PACKET *client_packet);
int client_packet_recv(int fd, struct sockaddr_in *addr,
	CLIENT_PACKET *client_packet);

int server_opcode_send(int fd, struct sockaddr_in *addr, int opcode);
int server_opcode_recv(int fd, struct sockaddr_in *addr);
int client_opcode_send(int fd, struct sockaddr_in *addr, int opcode);
int client_opcode_recv(int fd, struct sockaddr_in *addr);

#endif
