/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
#ifndef _BODY_H_
#define	_BODY_H_

#include <GL/gl.h>

typedef GLfloat GLfloat3[3] ;

#define SET_VEC3( v, x, y, z )  ( (v)[0] = (x), (v)[1] = (y), (v)[2] = (z) )
#define	SUB_VEC3( a, b, c )	( (a)[0] = (b)[0] - (c)[0], \
				  (a)[1] = (b)[1] - (c)[1], \
				  (a)[2] = (b)[2] - (c)[2] )
#define	COPY_VEC3( a, b )	( (a)[0] = (b)[0], \
				  (a)[1] = (b)[1], \
				  (a)[2] = (b)[2] )


/* BEGIN PROTOTYPES body.c */
void    createCar( void ) ;
void    cullDrawAllCars( int start, int n ) ;
void    defineCarMaterials( void ) ;
void    drawAllCars( int start, int n ) ;
void    setCarBaseLod( int lod ) ;
/* END PROTOTYPES body.c */

#endif /* !_BODY_H_ */
