/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
#ifndef	_CAR_H_
#define	_CAR_H_

typedef struct _car {
	int		status ;
	int		lap ;
	int		number ;
	int		headOn ;
	float		startLapTime ;
	float		bestLapTime ;
	float		finishTime ;
	float		lane ;
	float		s ;
	float		speed ;
	float		desiredSpeed ;
	float		x ;
	float		y ;
	float		theta ;
	float		wreckVel[2] ;
	float		spinAngle ;
	float		spinRate ;
	float		wreckTime ;
	float		totalDis ;
	float		lapDis ;
	char		name[VROOM_NAMELEN] ;
	struct _track	*track ;
	} Car ;

/* BEGIN PROTOTYPES car.c */
void    finishCar( int n ) ;
void    incrementLap( Car *car, float tOffset ) ;
void    informPosition( int place ) ;
void    initCarColors( void ) ;
void    placeCarsForStart( void ) ;
void    setIntroCarShot( void ) ;
void    showReason( int reason ) ;
void    startSkid( Car *car, float force, float dt ) ;
void    stopSkid( Car *car ) ;
void    updateCars( float eTime, int timeTrial ) ;
void    updatePlayerView( int i ) ;
void    wipeOutCar( Car *car, float x, float y, int spinDirection,
            int cause ) ;
/* END PROTOTYPES car.c */

#endif /* !_CAR_H_ */
