/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
#ifndef	_SOUND_H
#define	_SOUND_H

#define	SFX_ERR_NO_ERR		(0)
#define	SFX_ERR_NO_PORTS_AVAIL	(-1)
#define	SFX_ERR_NO_AUDIO_HW	(-2)
#define	SFX_ERR_NO_MEM		(-3)
#define	SFX_ERR_NO_SPROC	(-4)

typedef struct _sfx	*Sfx ;

/* BEGIN PROTOTYPES sound.c */
void    sfxDisable( Sfx s ) ;
void    sfxEnable( Sfx s ) ;
void    sfxEnd( void ) ;
void    sfxFree( Sfx s ) ;
int     sfxInit( char *audioDir, int numberOfPorts ) ;
Sfx     sfxLoad( char *filename ) ;
void    sfxLoop( Sfx s ) ;
void    sfxPitchBend( Sfx s, float startVal, float endVal, float startPitch,
            float endPitch, float basePitch, int steps ) ;
void    sfxPlay( Sfx s ) ;
void    sfxPlayPitch( Sfx s, float val ) ;
void    sfxSetVolume( int level ) ;
void    sfxSilenceLoop( Sfx s ) ;
int     sfxVolumeChange( int direction ) ;
/* END PROTOTYPES sound.c */

#endif /* _SOUND_H */
