/*
 * The original copyright owners of the accompanying source code files have
 * agreed to place such code into the public domain.  Accordingly, anyone
 * who receives or obtains a copy of such source code is freely entitled to
 * reproduce, use and otherwise exploit such code (including the right to
 * make derivative works), at his/her own risk and expense, without any
 * obligation or liability to the original copyright owners.
 *
 * We would appreciate (but do not require) that the following message be
 * included in any derivative works:
 *
 * "Portions of this program were developed by Peter Broadwell, Rob Myers
 * and Robin Schaufler while working in Silicon Valley."
 *
 * The accompanying source code files and related documentation materials
 * are distributed on an "AS IS" basis, without any warranties or
 * guarantees of any kind.  All implied warranties, including the implied
 * warranties of merchantability and of fitness for any particular purpose,
 * are expressly disclaimed.
 */
#include "gl.h"
#include "colors.h"

unsigned short scaleyTex1[] = {
    0xc7, 0xc7,   0x28, 0x28,   0x28, 0x28,   0x28, 0x28,
    0x10, 0x10,   0x10, 0x10,   0x10, 0x10,   0x10, 0x10,
    0x7c, 0x7c,   0x82, 0x82,   0x82, 0x82,   0x82, 0x82,
    0x01, 0x01,   0x01, 0x01,   0x01, 0x01,   0x01, 0x01,
};
unsigned short spottyTex2[] = {
    0x00, 0x00,   0x70, 0x70,   0x00, 0x00,   0x00, 0x00,
    0x03, 0x00,   0x40, 0x00,   0x00, 0x00,   0x00, 0x00,
    0x00, 0x00,   0x00, 0x08,   0x00, 0x00,   0x30, 0x00,
    0x00, 0x00,   0x00, 0x00,   0x00, 0x40,   0x50, 0x00,
};

setColorMap()
{
    mapcaller(WATER_COLOR,	000, 000, 155);	/* dark blue	 */

    mapcaller(SEAWEED_COLOR,	000, 220, 000);	/* dark green	 */
    mapcaller(MICA_COLOR,	000, 200, 210);	/* aqua      	 */
    mapcaller(GRANITE_COLOR,	160, 150, 160);	/* grey      	 */
    mapcaller(PHOSPHOR_COLOR,	160, 200, 160);	/* mint          */
    mapcaller(MAGNESIUM_COLOR,	160, 160, 200);	/* mauve     	 */
    mapcaller(CALCIUM_COLOR,	180, 190, 210);	/* cameo     	 */
    mapcaller(TEX_COLOR,	100,  90, 000);	/* dark brown  	 */

    mapcaller(BOWL_COLOR,	000, 255, 255);	/* cyan		 */
    mapcaller(EDGE_COLOR,	000, 000, 000);	/* black	 */
    mapcaller(GUPPYTAIL_COLOR,	230, 180, 000);	/* gold		 */
    mapcaller(GUPPYBODY_COLOR,	200, 150, 000);	/* dark gold	 */
    mapcaller(MINNOWTAIL_COLOR,	255, 200, 000);	/* orange	 */
    mapcaller(MINNOWBODY_COLOR,	255, 000, 000);	/* red		 */
    mapcaller(GUPPYEYE_COLOR,	  0, 255, 200);	/* cyan          */
    mapcaller(GUPPYIRIS_COLOR,	  0,   0, 100);	/* very dark blue*/
    mapcaller(MINNOWEYE_COLOR,	  0, 255, 160);	/* pale green    */
    mapcaller(MINNOWIRIS_COLOR,	  0, 128, 100);	/* slate blue    */
    mapcaller(BUBBLE_COLOR,	  0, 255, 255);	/* cyan          */
    mapcaller(EGG_COLOR,	210, 170, 160);	/* pale apricot	 */
    mapcaller(SELECT_COLOR,	255, 255, 000);	/* yellow 	 */
    mapcaller(PANEL_BLACK,	 80,  80,  80);	/* 30% gray 	 */
    mapcaller(PANEL_GRAY3,	128, 128, 128);	/* 50% gray 	 */
    mapcaller(PANEL_GRAY5,	192, 192, 192);	/* 75% gray 	 */
    mapcaller(PANEL_GRAY7,	217, 217, 217);	/* 85% gray 	 */
    mapcaller(PANEL_WHITE,	255, 255, 255);	/* white 	 */

    mapcaller(WIGGLER_COLOR,	050, 170, 180);	/*      	 */
    mapcaller(FEEDER_COLOR,	180, 200, 130);	/*      	 */
    mapcaller(FEMALE_COLOR,	130, 160, 200);	/*       	 */
    mapcaller(MALE_COLOR,	180, 190, 210);	/*       	 */
    mapcaller(COLORIZER_COLOR,	255, 255, 000);	/* yellow 	 */

    mapcaller(GHOST_COLOR,	240, 190, 000);	/* gold-orange   */
    mapcaller(TOADTOP_COLOR,	220, 120, 100);	/* greenish-gold-orange   */
    mapcaller(MODEL_COLOR_BASE,	250,   0, 253);	/* obnoxious hot pink */
}

typedef struct {unsigned char r,g,b;} tripl;
static tripl cmap[4096];

extern int doingRGB;
fishWritemask( Colorindex wtm )
{
    if(doingRGB) return;
    writemask(wtm);
}

fishColor(int index)
{
    register tripl *tp;

    tp = & cmap[index];
    color(index);
#if 0
    RGBcolor(tp->r, tp->g, tp->b);
#endif
}

mcolor(index,r,g,b)
    Colorindex index;
    RGBvalue r,g,b;
{
    register tripl *tp;

    tp = & cmap[index];
    tp->r = r;
    tp->g = g;
    tp->b = b;
    mapcolor(index,r,g,b);
}

gmcolor(index,r,g,b)
    Colorindex index;
    RGBvalue *r,*g,*b;
{
    register tripl *tp;

    tp = & cmap[index];
    *r = tp->r;
    *g = tp->g;
    *b = tp->b;
}

mapcaller(index,r,g,b)
    Colorindex index;
    RGBvalue r,g,b;
{
    register long i;
    register long j;

    if(index >= BACK_GROUND_BASE) {
		/* index'th row's first element */
	mcolor(index,r,g,b);
    }
    else {
		/* colomn over index */
	mcolor(index,r,g,b);
	for(j=BACK_GROUND_BASE,i=2;
	    i<=BACK_GROUND_BASE;
	    i <<= 1, j += BACK_GROUND_BASE) {
	    mcolor(index + j,r,g,b);
	}
    }
}


    /* color map index management stack */
#define MAXSTACK (BACK_GROUND_BASE-MODEL_COLOR_BASE)
static int tos = -1;
static int stack[MAXSTACK];
static nextModelColor = MODEL_COLOR_BASE+1;

    /*
     *  get the next available model color index
     */
getMapIndex()
{
    int index = MODEL_COLOR_BASE;

    if (tos >= 0) {		/* have we stored away any we can reuse? */
	if (tos < MAXSTACK)
	     index = stack[tos--];
	else printf("getMapIndex: tried to access off end of stack\n");
    }
    else {
	if (nextModelColor < BACK_GROUND_BASE)
	     index = nextModelColor++;
	else printf("getMapIndex: requested too many model colors\n");
    }
/**********
    printf("getMapIndex return %d with %d in the stack\n", index, tos);
/**********/
    return index;
}

    /*
     *  relinquish a previously obtained model color index
     */
freeMapIndex(index)
{
    if (tos+1 < MAXSTACK)
	stack[++tos] = index;
    else printf("freeMapIndex: stack overflow, index %d not saved\n", index);
}
