/*
 * The original copyright owners of the accompanying source code files have
 * agreed to place such code into the public domain.  Accordingly, anyone
 * who receives or obtains a copy of such source code is freely entitled to
 * reproduce, use and otherwise exploit such code (including the right to
 * make derivative works), at his/her own risk and expense, without any
 * obligation or liability to the original copyright owners.
 *
 * We would appreciate (but do not require) that the following message be
 * included in any derivative works:
 *
 * "Portions of this program were developed by Peter Broadwell, Rob Myers
 * and Robin Schaufler while working in Silicon Valley."
 *
 * The accompanying source code files and related documentation materials
 * are distributed on an "AS IS" basis, without any warranties or
 * guarantees of any kind.  All implied warranties, including the implied
 * warranties of merchantability and of fitness for any particular purpose,
 * are expressly disclaimed.
 */
#define COLOR_BASE 016
#define WATER_COLOR 	 (0)
#define REAL_BLACK 	 (8)
#define BOWL_COLOR 	 (COLOR_BASE+1)
#define EDGE_COLOR       (COLOR_BASE+2)
#define GUPPYTAIL_COLOR  (COLOR_BASE+3)
#define GUPPYBODY_COLOR  (COLOR_BASE+4)
#define MINNOWTAIL_COLOR (COLOR_BASE+5)
#define MINNOWBODY_COLOR (COLOR_BASE+6)
#define GUPPYEYE_COLOR 	 (COLOR_BASE+7)
#define GUPPYIRIS_COLOR	 (COLOR_BASE+8)
#define MINNOWEYE_COLOR  (COLOR_BASE+9)
#define MINNOWIRIS_COLOR (COLOR_BASE+10)
#define BUBBLE_COLOR	 (COLOR_BASE+11)
#define EGG_COLOR	 (COLOR_BASE+12)
#define SELECT_COLOR	 (COLOR_BASE+13)
#define PANEL_BLACK	 (COLOR_BASE+14)
#define PANEL_GRAY7	 (COLOR_BASE+15)
#define PANEL_GRAY5	 (COLOR_BASE+16)
#define PANEL_GRAY3	 (COLOR_BASE+17)
#define PANEL_WHITE	 (COLOR_BASE+18)

#define COLORIZER_COLOR	 (COLOR_BASE+19)
#define WIGGLER_COLOR	 (COLOR_BASE+20)
#define FEEDER_COLOR	 (COLOR_BASE+21)
#define FEMALE_COLOR	 (COLOR_BASE+22)
#define MALE_COLOR	 (COLOR_BASE+23)

#define GHOST_COLOR	 (COLOR_BASE+24)
#define TOADTOP_COLOR	 (COLOR_BASE+25)
#define TOADSTONE_COLOR	 TOADTOP_COLOR
    /* add new colors before COLOR_TOP, then bump his number to be highest */
#define COLOR_TOP	 (COLOR_BASE+26)

    /* things that don't need to be sorted each cycle
	shoule be drawn offset by this ammount */
#define BACK_GROUND_BASE	128
#define SEAWEED_COLOR 	 (BACK_GROUND_BASE*1)
#define MICA_COLOR 	 (BACK_GROUND_BASE*2) /* for pebbles */
#define GRANITE_COLOR 	 (BACK_GROUND_BASE*3)
#define PHOSPHOR_COLOR 	 (BACK_GROUND_BASE*4) /*     ...     */
#define MAGNESIUM_COLOR  (BACK_GROUND_BASE*5)
#define CALCIUM_COLOR 	 (BACK_GROUND_BASE*6) /* for pebbles */
#define TEX_COLOR 	 (BACK_GROUND_BASE*7) /* for pebbles */

    /* begin model-specific colors here; they increment up for each model */
#define MODEL_COLOR_BASE (COLOR_TOP+1)

    /* texture pattern definitions */
#define NO_TEXTURE 	0
#define SCALEY_TEX1 	1
#define SPOTTY_TEX2 	2

#define GUPPYTAIL_TEXTURE  NO_TEXTURE
#define GUPPYBODY_TEXTURE  NO_TEXTURE
#define MINNOWTAIL_TEXTURE NO_TEXTURE
#define MINNOWBODY_TEXTURE NO_TEXTURE
#define SEAWEED_TEXTURE    NO_TEXTURE
#define PEBBLE_TEXTURE	   SPOTTY_TEX2
#define GUPPYEYE_TEXTURE   NO_TEXTURE
#define GUPPYIRIS_TEXTURE  NO_TEXTURE
#define MINNOWEYE_TEXTURE  NO_TEXTURE
#define MINNOWIRIS_TEXTURE NO_TEXTURE
#define BUBBLE_TEXTURE	   NO_TEXTURE
#define EGG_TEXTURE	   NO_TEXTURE
#define SELECT_TEXTURE	   NO_TEXTURE
#define GHOST_TEXTURE	   NO_TEXTURE	/* for now */
#define TOADSTONE_TEXTURE  NO_TEXTURE

#define FOREGROUND	0x7f
#define BACKGROUND	0xfff
#define NOGROUND	0x0

