/*
 * The original copyright owners of the accompanying source code files have
 * agreed to place such code into the public domain.  Accordingly, anyone
 * who receives or obtains a copy of such source code is freely entitled to
 * reproduce, use and otherwise exploit such code (including the right to
 * make derivative works), at his/her own risk and expense, without any
 * obligation or liability to the original copyright owners.
 *
 * We would appreciate (but do not require) that the following message be
 * included in any derivative works:
 *
 * "Portions of this program were developed by Peter Broadwell, Rob Myers
 * and Robin Schaufler while working in Silicon Valley."
 *
 * The accompanying source code files and related documentation materials
 * are distributed on an "AS IS" basis, without any warranties or
 * guarantees of any kind.  All implied warranties, including the implied
 * warranties of merchantability and of fitness for any particular purpose,
 * are expressly disclaimed.
 */
#include "gl.h"
#include "geom.h"
#include "class.h"
#include "selectors.h"
#include "classIds.h"
#include "mbox.h"
#include "individual.h"
#include "behavior.h"
#include "colors.h"
#include "pick.h"
#include "doers.h"
#include "panel.h"
#include "valuator.h"
#include "objIds.h"

extern subscr *findvars();
extern individual *replicateModel();
extern individual *us;
extern behavior faderTemplate;
extern int dumper;

    /*
     *  instantiate and initialize a ghost's model list
     *  and give it its default behavior.
     */
    individual *
initGhost(self)
    register individual *self;
{
	/* reproduce list of model segments */
    replicateModel(self);
	/* subscribe to default behavior */
    subscribe(&faderTemplate, self);

    return self;
}
