/*
 * The original copyright owners of the accompanying source code files have
 * agreed to place such code into the public domain.  Accordingly, anyone
 * who receives or obtains a copy of such source code is freely entitled to
 * reproduce, use and otherwise exploit such code (including the right to
 * make derivative works), at his/her own risk and expense, without any
 * obligation or liability to the original copyright owners.
 *
 * We would appreciate (but do not require) that the following message be
 * included in any derivative works:
 *
 * "Portions of this program were developed by Peter Broadwell, Rob Myers
 * and Robin Schaufler while working in Silicon Valley."
 *
 * The accompanying source code files and related documentation materials
 * are distributed on an "AS IS" basis, without any warranties or
 * guarantees of any kind.  All implied warranties, including the implied
 * warranties of merchantability and of fitness for any particular purpose,
 * are expressly disclaimed.
 */
    /*
     *  NOTE: use &model as Id for compiled rendering context for this model
     */
typedef struct _model {
    struct _model *next;
    struct _model *kids;
    char compiled;	/* TRUE = geometry has been compiled already */
    Object component;	/* Id for compiled geometry for this model   */
    point *points;
    long *vertices;
    point centroid;
    long color;
    long texture;
    long outlined;
    point rotation;	/* x, y, and z-axis rotations of model segment */
    point translate;	/* x, y, and z-axis translate of model segment */
    fpoint scale;	/* x, y, and z-axis scale     of model segment */
    int declasse;	/* how unsophisticated is this component? */
} model;

typedef struct {
    mailbox them;
    point position;
    point lastPosition;
    point delta;	/* position - lastposition */
    point velocity;
    point avelocity;
    point acceleration;
    float speed;
    fpoint heading;
    point rotation;	/* x, y, and z-axis rotations of entire individual  */
    point influence;	/* motion is influenced by vector influence	    */
    float scale;	/* uniform scaling of individual about its position */
    model *descr;
    long  flags;	/* ORDER => do in descr order, else PICKED | ~PICKED */
    subscr *curVars;	/* current subscribedTo entry, to get instance vars */
    char  *controls;	/* control panel for this individual */
} individual;

typedef struct {
    RGBvalue r, g, b;
} rgbcolor;

#define ORDER 0x1
#define PICKED 0x2
