/*
 * The original copyright owners of the accompanying source code files have
 * agreed to place such code into the public domain.  Accordingly, anyone
 * who receives or obtains a copy of such source code is freely entitled to
 * reproduce, use and otherwise exploit such code (including the right to
 * make derivative works), at his/her own risk and expense, without any
 * obligation or liability to the original copyright owners.
 *
 * We would appreciate (but do not require) that the following message be
 * included in any derivative works:
 *
 * "Portions of this program were developed by Peter Broadwell, Rob Myers
 * and Robin Schaufler while working in Silicon Valley."
 *
 * The accompanying source code files and related documentation materials
 * are distributed on an "AS IS" basis, without any warranties or
 * guarantees of any kind.  All implied warranties, including the implied
 * warranties of merchantability and of fitness for any particular purpose,
 * are expressly disclaimed.
 */
typedef struct {
    panel base;
    int flags;
    point2d nbuttons;	/* number of buttons across and up */
    int curVal;		/* current button, counted row major from top */
    inst *receiver;	/* object to receive button message upon pick */
    int baseSelect;	/* base of selectors for button messages */
			/* first button sends message baseSelect */
			/* last button sends baseSelect+nbuttons.x*nbuttons.y */
    Object highlight;
} menu;

typedef struct {
    panel base;
    int flags;
    point2d nbuttons;	/* number of buttons across and up */
    int curVal;		/* current button, counted row major from top */
    int *baseChoice;	/* base of value choice array */
    int *value;		/* address of client value, to be read and stuffed */
    Object highlight;
} choice;

typedef struct {
    panel base;
    int flags;
    point2d nbuttons;	/* number of buttons across and up */
    int curVal;		/* current button, counted row major from top */
    Coord *baseChoice;	/* base of value choice array */
    Coord *value;	/* address of client value, to be read and stuffed */
    Object highlight;
} choicef;
