/*
 * The original copyright owners of the accompanying source code files have
 * agreed to place such code into the public domain.  Accordingly, anyone
 * who receives or obtains a copy of such source code is freely entitled to
 * reproduce, use and otherwise exploit such code (including the right to
 * make derivative works), at his/her own risk and expense, without any
 * obligation or liability to the original copyright owners.
 *
 * We would appreciate (but do not require) that the following message be
 * included in any derivative works:
 *
 * "Portions of this program were developed by Peter Broadwell, Rob Myers
 * and Robin Schaufler while working in Silicon Valley."
 *
 * The accompanying source code files and related documentation materials
 * are distributed on an "AS IS" basis, without any warranties or
 * guarantees of any kind.  All implied warranties, including the implied
 * warranties of merchantability and of fitness for any particular purpose,
 * are expressly disclaimed.
 */
#include <math.h>
#include "gl.h"
#include "device.h"
#include "geom.h"
#include "class.h"
#include "classIds.h"
#include "selectors.h"
#include "mbox.h"
#include "individual.h"
#include "behavior.h"
#include "doers.h"
#include "colors.h"
#include "objIds.h"

#include "toad.h"

#define PI 3.14159265358979323844
#define DEG(x) ((float)x*(float)180/PI)
#define RAD(x) ((float)x*PI/(float)180)

extern char frozen;
extern char bullet;


/* ARGSUSED */
toadinit(s, argtype, univol)
    register individual *s;
    int argtype;
    point *univol;
{
#if 1
    /* this function is not fleshed out yet, might never be */
    return;
#else
    register model *myModel;

    replicateModel(s);	/* first, instantiate and initialize the model */
    myModel = s->descr;	/* use newly instantiated model */

    makeobj(myModel);
	pushLongName(s);
	backface(FALSE);
	fishWritemask(BACKGROUND);
	fishColor(myModel->color);

	backface(TRUE);
	popLongName();
    closeobj();
    myModel->compiled = TRUE;
    myModel->component = (Object)myModel;
#endif
}
 
