/*
 * The original copyright owners of the accompanying source code files have
 * agreed to place such code into the public domain.  Accordingly, anyone
 * who receives or obtains a copy of such source code is freely entitled to
 * reproduce, use and otherwise exploit such code (including the right to
 * make derivative works), at his/her own risk and expense, without any
 * obligation or liability to the original copyright owners.
 *
 * We would appreciate (but do not require) that the following message be
 * included in any derivative works:
 *
 * "Portions of this program were developed by Peter Broadwell, Rob Myers
 * and Robin Schaufler while working in Silicon Valley."
 *
 * The accompanying source code files and related documentation materials
 * are distributed on an "AS IS" basis, without any warranties or
 * guarantees of any kind.  All implied warranties, including the implied
 * warranties of merchantability and of fitness for any particular purpose,
 * are expressly disclaimed.
 */
#include "gl.h"

#include "geom.h"
#include "class.h"
#include "classIds.h"
#include "selectors.h"
#include "mbox.h"
#include "individual.h"

extern class indivClass;

extern char *bselNone(), *eselNone();

fcnTable usTable[] = {
    DOIT,       NULL,		/* don't DOIT as a subscribedTo by others */
    SELECT,	NULL,		/* don't conduct individual's hit processing */
    DESELECT,	NULL,
    BEGINSELECT,bselNone,
    ENDSELECT,	eselNone,
    POSTBEHAVE,	NULL,		/* don't post a behavior */
    ADDPANEL,	NULL,		/* don't show a panel */
    EOTABLE,
};

class usClass = {
    &indivClass,
    usTable,
    sizeof(individual),
    US,
};

individual usTemplate = {
			/*   inst		*/
    &usClass,		/* myClass pointer	*/
    NULL,		/* classFunctions 	*/
    0,			/* nFunctions		*/
			/*   mailbox		*/
    NULL,		/* subscribers          */
    NULL,		/* subscribedTo         */
    			/*   individual         */
    {0,0,0},		/* position		*/
    {0,0,0},		/* lastPosition		*/
    {1,0,0},		/* delta		*/
    {0,0,0},		/* velocity		*/
    {0,0,0},		/* avelocity		*/
    {0,0,0},		/* acceleration		*/
    NULL,		/* model		*/
    NULL,		/* flags		*/
    NULL,		/* curVars		*/
};

