/*
 * The original copyright owners of the accompanying source code files have
 * agreed to place such code into the public domain.  Accordingly, anyone
 * who receives or obtains a copy of such source code is freely entitled to
 * reproduce, use and otherwise exploit such code (including the right to
 * make derivative works), at his/her own risk and expense, without any
 * obligation or liability to the original copyright owners.
 *
 * We would appreciate (but do not require) that the following message be
 * included in any derivative works:
 *
 * "Portions of this program were developed by Peter Broadwell, Rob Myers
 * and Robin Schaufler while working in Silicon Valley."
 *
 * The accompanying source code files and related documentation materials
 * are distributed on an "AS IS" basis, without any warranties or
 * guarantees of any kind.  All implied warranties, including the implied
 * warranties of merchantability and of fitness for any particular purpose,
 * are expressly disclaimed.
 */
#include "gl.h"
#include "geom.h"
#include "class.h"
#include "classIds.h"
#include "selectors.h"
#include "mbox.h"
#include "panel.h"
#include "valuator.h"
#include "colors.h"

extern class panelClass;

extern char *selectVal(), *drawVal();

fcnTable valTable[] = {
    SELECT,	selectVal,
    DRAWTRACKER,drawVal,
    EOTABLE,
};

class valClass = {
    &panelClass,
    valTable,
    sizeof(valuator),
    VALUATOR,
};

valuator valTemplate = {
			/*   inst		*/
    &valClass,		/* myClass pointer	*/
			/* the rest is all NULLs*/
};

extern char *selectValf(), *drawValf();

fcnTable valfTable[] = {
    SELECT,	selectValf,
    DRAWTRACKER,drawValf,
    EOTABLE,
};

class valfClass = {
    &panelClass,
    valfTable,
    sizeof(valuatorf),
    VALUATORF,
};

valuatorf valfTemplate = {
			/*   inst		*/
    &valfClass,		/* myClass pointer	*/
			/* the rest is all NULLs*/
};

extern char *selectValDelta();

fcnTable valDeltaTable[] = {
    SELECT,	selectValDelta,
    DRAWTRACKER,NULL,
    EOTABLE,
};

class valDeltaClass = {
    &valClass,
    valDeltaTable,
    sizeof(valdelta),
    VALDELTA,
};

valdelta valDeltaTemplate = {
			/*   inst		*/
    &valDeltaClass,	/* myClass pointer	*/
			/* the rest is all NULLs*/
};

extern char *selectValDeltaf();

fcnTable valDeltafTable[] = {
    SELECT,	selectValDeltaf,
    DRAWTRACKER,NULL,
    EOTABLE,
};

class valDeltafClass = {
    &valfClass,
    valDeltafTable,
    sizeof(valdeltaf),
    VALDELTAF,
};

valdeltaf valDeltafTemplate = {
			/*   inst		*/
    &valDeltafClass,	/* myClass pointer	*/
			/* the rest is all NULLs*/
};

extern char *selectValMesg(), *drawValMesg(), *resetValMesg(), *oselValMesg();

fcnTable valMesgTable[] = {
    SELECT,	selectValMesg,
    DRAWTRACKER,drawValMesg,
    KILLSELECT,	resetValMesg,
    RESET,	resetValMesg,
    EOTABLE,
};

class valMesgClass = {
    &valClass,
    valMesgTable,
    sizeof(valmesg),
    VALMESG,
};

valmesg valMesgTemplate = {
			/*   inst		*/
    &valMesgClass,	/* myClass pointer	*/
			/* the rest is all NULLs*/
};

extern char *selectValMesgf(),*drawValMesgf(), *resetValMesgf(),*oselValMesgf();

fcnTable valMesgfTable[] = {
    SELECT,	selectValMesgf,
    DRAWTRACKER,drawValMesgf,
    KILLSELECT,	resetValMesgf,
    RESET,	resetValMesgf,
    EOTABLE,
};

class valMesgfClass = {
    &valfClass,
    valMesgfTable,
    sizeof(valmesgf),
    VALMESGF,
};

valmesgf valMesgfTemplate = {
			/*   inst		*/
    &valMesgfClass,	/* myClass pointer	*/
			/* the rest is all NULLs*/
};

fcnTable valHueTable[] = {
    EOTABLE,
};

class valHueClass = {
    &valClass,
    valHueTable,
    sizeof(valhue),
    VALHUE,
};

valhue valHueTemplate = {
			/*   inst		*/
    &valHueClass,	/* myClass pointer	*/
			/* the rest is all NULLs*/
};

fcnTable valValTable[] = {
    EOTABLE,
};

class valValClass = {
    &valClass,
    valValTable,
    sizeof(valval),
    VALVAL,
};

valval valValTemplate = {
			/*   inst		*/
    &valValClass,	/* myClass pointer	*/
			/* the rest is all NULLs*/
};

