/*
 * The original copyright owners of the accompanying source code files have
 * agreed to place such code into the public domain.  Accordingly, anyone
 * who receives or obtains a copy of such source code is freely entitled to
 * reproduce, use and otherwise exploit such code (including the right to
 * make derivative works), at his/her own risk and expense, without any
 * obligation or liability to the original copyright owners.
 *
 * We would appreciate (but do not require) that the following message be
 * included in any derivative works:
 *
 * "Portions of this program were developed by Peter Broadwell, Rob Myers
 * and Robin Schaufler while working in Silicon Valley."
 *
 * The accompanying source code files and related documentation materials
 * are distributed on an "AS IS" basis, without any warranties or
 * guarantees of any kind.  All implied warranties, including the implied
 * warranties of merchantability and of fitness for any particular purpose,
 * are expressly disclaimed.
 */
    /*
     *  A voxel is a unit of 3D space.
     *  It's superclass is mailbox.
     */
#define NDIMENSIONS	3
#define VOX_X		0
#define VOX_Y		1
#define VOX_Z		2

#define NDIRECTIONS	2
#define NEXT		0
#define PREV		1
#define STATION		-1

#define CONTINUE	0
#define HALT		-1

typedef inst *link;

typedef struct {
    mailbox mbox;
    link dim [NDIMENSIONS] [NDIRECTIONS];
    cube volume;
} voxel;
